-- Fredzaza --
-- TMP --
-- @date 08/12/2019 --

Attacher = {};

function Attacher.prerequisitesPresent(specializations)
      return true;
end;
function Attacher.initSpecialization()
end
function Attacher.registerOverwrittenFunctions(vehicleType)
end
function Attacher.registerFunctions(vehicleType)	
end
function Attacher.registerEvents(vehicleType)
end
function Attacher:registerActionEventsPlayer()
end
function Attacher:registerActionEventsMenu()
end

function Attacher:onRegisterActionEvents(isSelected, isOnActiveVehicle)
	if isOnActiveVehicle then
		if self.Attacher == nil then 
			self.Attacher = {}
		else	
			self:clearActionEventsTable( self.Attacher )
		end 
	end
end

function Attacher.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", Attacher)
	SpecializationUtil.registerEventListener(vehicleType, "onDelete", Attacher)
    SpecializationUtil.registerEventListener(vehicleType, "onReadStream", Attacher)
    SpecializationUtil.registerEventListener(vehicleType, "onWriteStream", Attacher)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", Attacher)
	SpecializationUtil.registerEventListener(vehicleType, "onDeactivate", Attacher)
	SpecializationUtil.registerEventListener(vehicleType, "onDraw", Attacher)
	SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", Attacher)
end

function Attacher:onLoad(vehicle)	

	self.baseprincipal = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.attacher_principal#index"));
	self.attacher_visual = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.attacher_visual#index"));
	
	self.attachervisual = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.attachervisual#index"));
end;

function Attacher:onDelete() 
end;

function Attacher:onReadStream(streamId, connection)
end;
  
function Attacher:onWriteStream(streamId, connection)
end;

function Attacher:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Attacher:keyEvent(unicode, sym, modifier, isDown)    
end;

function Attacher:onUpdate(dt, vehicle)
		local attacherVehicle = self:getAttacherVehicle()
		if attacherVehicle ~= nil then
			if attacherVehicle.attachervisual ~= nil then
				link(attacherVehicle.attachervisual, self.attacher_visual)
			end
		else
			unlink(self.attacher_visual)
			link(self.baseprincipal, self.attacher_visual)
        end
end;

function Attacher:onUpdateTick() 
end;	
function Attacher:onDeactivate()
	unlink(self.attacher_visual)
	link(self.baseprincipal, self.attacher_visual)
end;       
function Attacher:onDraw()  
end;
